Loading...
Searching...
No Matches
wayland::zwp_tablet_tool_v2_t Class Reference

a physical tablet tool More...

`#include <wayland-client-protocol-unstable.hpp>`

Inheritance diagram for wayland::zwp_tablet_tool_v2_t:
[legend]
Collaboration diagram for wayland::zwp_tablet_tool_v2_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

void | set_cursor (uint32_t serial, surface_t const &surface, int32_t hotspot_x, int32_t hotspot_y)
| set the tablet tool's surface
std::function< void(zwp_tablet_tool_v2_type)> & | on_type ()
| tool type
std::function< void(uint32_t, uint32_t)> & | on_hardware_serial ()
| unique hardware serial number of the tool
std::function< void(uint32_t, uint32_t)> & | on_hardware_id_wacom ()
| hardware id notification in Wacom's format
std::function< void(zwp_tablet_tool_v2_capability)> & | on_capability ()
| tool capability notification
std::function< void()> & | on_done ()
| tool description events sequence complete
std::function< void()> & | on_removed ()
| tool removed
std::function< void(uint32_t, zwp_tablet_v2_t, surface_t)> & | on_proximity_in ()
| proximity in event
std::function< void()> & | on_proximity_out ()
| proximity out event
std::function< void(uint32_t)> & | on_down ()
| tablet tool is making contact
std::function< void()> & | on_up ()
| tablet tool is no longer making contact
std::function< void(double, double)> & | on_motion ()
| motion event
std::function< void(uint32_t)> & | on_pressure ()
| pressure change event
std::function< void(uint32_t)> & | on_distance ()
| distance change event
std::function< void(double, double)> & | on_tilt ()
| tilt change event
std::function< void(double)> & | on_rotation ()
| z-rotation change event
std::function< void(int32_t)> & | on_slider ()
| Slider position change event.
std::function< void(double, int32_t)> & | on_wheel ()
| Wheel delta event.
std::function< void(uint32_t, uint32_t, zwp_tablet_tool_v2_button_state)> & | on_button ()
| button event
std::function< void(uint32_t)> & | on_frame ()
| frame event
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | set_cursor_since_version = 1
| Minimum protocol version required for the set_cursor function.

## Detailed Description

a physical tablet tool

An object that represents a physical tool that has been, or is currently in use with a tablet in this seat. Each wp_tablet_tool object stays valid until the client destroys it; the compositor reuses the wp_tablet_tool object to indicate that the object's respective physical tool has come into proximity of a tablet again.

A wp_tablet_tool object's relation to a physical tool depends on the tablet's ability to report serial numbers. If the tablet supports this capability, then the object represents a specific physical tool and can be identified even when used on multiple tablets.

A tablet tool has a number of static characteristics, e.g. tool type, hardware_serial and capabilities. These capabilities are sent in an event sequence after the wp_tablet_seat.tool_added event before any actual events from this tool. This initial event sequence is terminated by a wp_tablet_tool.done event.

Tablet tool events are grouped by wp_tablet_tool.frame events. Any events received before a wp_tablet_tool.frame event should be considered part of the same hardware state change.

Definition at line 4368 of file wayland-client-protocol-unstable.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 116 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 302 of file wayland-client.hpp.

## on_button()

std::function< void(uint32_t, uint32_t, zwp_tablet_tool_v2_button_state)> & zwp_tablet_tool_v2_t::on_button | ( |  | ) |

button event

Parameters

  serial |
  button | The button whose state has changed
  state | Whether the button was pressed or released

Sent whenever a button on the tool is pressed or released.

If a button is held down when the tool moves in or out of proximity, button events are generated by the compositor. See wp_tablet_tool.proximity_in and wp_tablet_tool.proximity_out for details.

Definition at line 7470 of file wayland-client-protocol-unstable.cpp.

## on_capability()

std::function< void(zwp_tablet_tool_v2_capability)> & zwp_tablet_tool_v2_t::on_capability | ( |  | ) |

tool capability notification

Parameters

  capability | the capability

This event notifies the client of any capabilities of this tool, beyond the main set of x/y axes and tip up/down detection.

One event is sent for each extra capability available on this tool.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 7400 of file wayland-client-protocol-unstable.cpp.

## on_distance()

std::function< void(uint32_t)> & zwp_tablet_tool_v2_t::on_distance | ( |  | ) |

distance change event

Parameters

  distance | The current distance value

Sent whenever the distance axis on a tool changes. The value of this event is normalized to a value between 0 and 65535.

Note that distance may be nonzero even when a tool is not in logical contact. See the down and up events for more details.

Definition at line 7445 of file wayland-client-protocol-unstable.cpp.

## on_done()

std::function< void()> & zwp_tablet_tool_v2_t::on_done | ( |  | ) |

tool description events sequence complete

This event signals the end of the initial burst of descriptive events. A client may consider the static description of the tool to be complete and finalize initialization of the tool.

Definition at line 7405 of file wayland-client-protocol-unstable.cpp.

## on_down()

std::function< void(uint32_t)> & zwp_tablet_tool_v2_t::on_down | ( |  | ) |

tablet tool is making contact

Parameters

  serial |

Sent whenever the tablet tool comes in contact with the surface of the tablet.

If the tool is already in contact with the tablet when entering the input region, the client owning said region will receive a wp_tablet.proximity_in event, followed by a wp_tablet.down event and a wp_tablet.frame event.

Note that this event describes logical contact, not physical contact. On some devices, a compositor may not consider a tool in logical contact until a minimum physical pressure threshold is exceeded.

Definition at line 7425 of file wayland-client-protocol-unstable.cpp.

## on_frame()

std::function< void(uint32_t)> & zwp_tablet_tool_v2_t::on_frame | ( |  | ) |

frame event

Parameters

  time | The time of the event with millisecond granularity

Marks the end of a series of axis and/or button updates from the tablet. The Wayland protocol requires axis updates to be sent sequentially, however all events within a frame should be considered one hardware event.

Definition at line 7475 of file wayland-client-protocol-unstable.cpp.

## on_hardware_id_wacom()

std::function< void(uint32_t, uint32_t)> & zwp_tablet_tool_v2_t::on_hardware_id_wacom | ( |  | ) |

hardware id notification in Wacom's format

Parameters

  hardware_id_hi | the hardware id, most significant bits
  hardware_id_lo | the hardware id, least significant bits

This event notifies the client of a hardware id available on this tool.

The hardware id is a device-specific 64-bit id that provides extra information about the tool in use, beyond the wl_tool.type enumeration. The format of the id is specific to tablets made by Wacom Inc. For example, the hardware id of a Wacom Grip Pen (a stylus) is 0x802.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 7395 of file wayland-client-protocol-unstable.cpp.

## on_hardware_serial()

std::function< void(uint32_t, uint32_t)> & zwp_tablet_tool_v2_t::on_hardware_serial | ( |  | ) |

unique hardware serial number of the tool

Parameters

  hardware_serial_hi | the unique serial number of the tool, most significant bits
  hardware_serial_lo | the unique serial number of the tool, least significant bits

If the physical tool can be identified by a unique 64-bit serial number, this event notifies the client of this serial number.

If multiple tablets are available in the same seat and the tool is uniquely identifiable by the serial number, that tool may move between tablets.

Otherwise, if the tool has no serial number and this event is missing, the tool is tied to the tablet it first comes into proximity with. Even if the physical tool is used on multiple tablets, separate wp_tablet_tool objects will be created, one per tablet.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 7390 of file wayland-client-protocol-unstable.cpp.

## on_motion()

std::function< void(double, double)> & zwp_tablet_tool_v2_t::on_motion | ( |  | ) |

motion event

Parameters

  x | surface-local x coordinate
  y | surface-local y coordinate

Sent whenever a tablet tool moves.

Definition at line 7435 of file wayland-client-protocol-unstable.cpp.

## on_pressure()

std::function< void(uint32_t)> & zwp_tablet_tool_v2_t::on_pressure | ( |  | ) |

pressure change event

Parameters

  pressure | The current pressure value

Sent whenever the pressure axis on a tool changes. The value of this event is normalized to a value between 0 and 65535.

Note that pressure may be nonzero even when a tool is not in logical contact. See the down and up events for more details.

Definition at line 7440 of file wayland-client-protocol-unstable.cpp.

## on_proximity_in()

std::function< void(uint32_t, zwp_tablet_v2_t, surface_t)> & zwp_tablet_tool_v2_t::on_proximity_in | ( |  | ) |

proximity in event

Parameters

  serial |
  tablet | The tablet the tool is in proximity of
  surface | The current surface the tablet tool is over

Notification that this tool is focused on a certain surface.

This event can be received when the tool has moved from one surface to another, or when the tool has come back into proximity above the surface.

If any button is logically down when the tool comes into proximity, the respective button event is sent after the proximity_in event but within the same frame as the proximity_in event.

Definition at line 7415 of file wayland-client-protocol-unstable.cpp.

## on_proximity_out()

std::function< void()> & zwp_tablet_tool_v2_t::on_proximity_out | ( |  | ) |

proximity out event

Notification that this tool has either left proximity, or is no longer focused on a certain surface.

When the tablet tool leaves proximity of the tablet, button release events are sent for each button that was held down at the time of leaving proximity. These events are sent before the proximity_out event but within the same wp_tablet.frame.

If the tool stays within proximity of the tablet, but the focus changes from one surface to another, a button release event may not be sent until the button is actually released or the tool leaves the proximity of the tablet.

Definition at line 7420 of file wayland-client-protocol-unstable.cpp.

## on_removed()

std::function< void()> & zwp_tablet_tool_v2_t::on_removed | ( |  | ) |

tool removed

This event is sent when the tool is removed from the system and will send no further events. Should the physical tool come back into proximity later, a new wp_tablet_tool object will be created.

It is compositor-dependent when a tool is removed. A compositor may remove a tool on proximity out, tablet removal or any other reason. A compositor may also keep a tool alive until shutdown.

If the tool is currently in proximity, a proximity_out event will be sent before the removed event. See wp_tablet_tool.proximity_out for the handling of any buttons logically down.

When this event is received, the client must wp_tablet_tool.destroy the object.

Definition at line 7410 of file wayland-client-protocol-unstable.cpp.

## on_rotation()

std::function< void(double)> & zwp_tablet_tool_v2_t::on_rotation | ( |  | ) |

z-rotation change event

Parameters

  degrees | The current rotation of the Z axis

Sent whenever the z-rotation axis on the tool changes. The rotation value is in degrees clockwise from the tool's logical neutral position.

Definition at line 7455 of file wayland-client-protocol-unstable.cpp.

## on_slider()

std::function< void(int32_t)> & zwp_tablet_tool_v2_t::on_slider | ( |  | ) |

Slider position change event.

Parameters

  position | The current position of slider

Sent whenever the slider position on the tool changes. The value is normalized between -65535 and 65535, with 0 as the logical neutral position of the slider.

The slider is available on e.g. the Wacom Airbrush tool.

Definition at line 7460 of file wayland-client-protocol-unstable.cpp.

## on_tilt()

std::function< void(double, double)> & zwp_tablet_tool_v2_t::on_tilt | ( |  | ) |

tilt change event

Parameters

  tilt_x | The current value of the X tilt axis
  tilt_y | The current value of the Y tilt axis

Sent whenever one or both of the tilt axes on a tool change. Each tilt value is in degrees, relative to the z-axis of the tablet. The angle is positive when the top of a tool tilts along the positive x or y axis.

Definition at line 7450 of file wayland-client-protocol-unstable.cpp.

## on_type()

std::function< void(zwp_tablet_tool_v2_type)> & zwp_tablet_tool_v2_t::on_type | ( |  | ) |

tool type

Parameters

  tool_type | the physical tool type

The tool type is the high-level type of the tool and usually decides the interaction expected from this tool.

This event is sent in the initial burst of events before the wp_tablet_tool.done event.

Definition at line 7385 of file wayland-client-protocol-unstable.cpp.

## on_up()

std::function< void()> & zwp_tablet_tool_v2_t::on_up | ( |  | ) |

tablet tool is no longer making contact

Sent whenever the tablet tool stops making contact with the surface of the tablet, or when the tablet tool moves out of the input region and the compositor grab (if any) is dismissed.

If the tablet tool moves out of the input region while in contact with the surface of the tablet and the compositor does not have an ongoing grab on the surface, the client owning said region will receive a wp_tablet.up event, followed by a wp_tablet.proximity_out event and a wp_tablet.frame event. If the compositor has an ongoing grab on this device, this event sequence is sent whenever the grab is dismissed in the future.

Note that this event describes logical contact, not physical contact. On some devices, a compositor may not consider a tool out of logical contact until physical pressure falls below a specific threshold.

Definition at line 7430 of file wayland-client-protocol-unstable.cpp.

## on_wheel()

std::function< void(double, int32_t)> & zwp_tablet_tool_v2_t::on_wheel | ( |  | ) |

Wheel delta event.

Parameters

  degrees | The wheel delta in degrees
  clicks | The wheel delta in discrete clicks

Sent whenever the wheel on the tool emits an event. This event contains two values for the same axis change. The degrees value is in the same orientation as the wl_pointer.vertical_scroll axis. The clicks value is in discrete logical clicks of the mouse wheel. This value may be zero if the movement of the wheel was less than one logical click.

Clients should choose either value and avoid mixing degrees and clicks. The compositor may accumulate values smaller than a logical click and emulate click events when a certain threshold is met. Thus, wl_tablet_tool.wheel events with non-zero clicks values may have different degrees values.

Definition at line 7465 of file wayland-client-protocol-unstable.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## set_cursor()

void zwp_tablet_tool_v2_t::set_cursor | ( | uint32_t | serial,
|  | surface_t const & | surface,
|  | int32_t | hotspot_x,
|  | int32_t | hotspot_y
| ) |  |

set the tablet tool's surface

Parameters

  serial | serial of the enter event
  surface |
  hotspot_x | surface-local x coordinate
  hotspot_y | surface-local y coordinate

Sets the surface of the cursor used for this tool on the given tablet. This request only takes effect if the tool is in proximity of one of the requesting client's surfaces or the surface parameter is the current pointer surface. If there was a previous surface set with this request it is replaced. If surface is NULL, the cursor image is hidden.

The parameters hotspot_x and hotspot_y define the position of the pointer surface relative to the pointer location. Its top-left corner is always at (x, y) - (hotspot_x, hotspot_y), where (x, y) are the coordinates of the pointer location, in surface-local coordinates.

On surface.attach requests to the pointer surface, hotspot_x and hotspot_y are decremented by the x and y parameters passed to the request. Attach must be confirmed by wl_surface.commit as usual.

The hotspot can also be updated by passing the currently set pointer surface to this request with new values for hotspot_x and hotspot_y.

The current and pending input regions of the wl_surface are cleared, and wl_surface.set_input_region is ignored until the wl_surface is no longer used as the cursor. When the use as a cursor ends, the current and pending input regions become undefined, and the wl_surface is unmapped.

This request gives the surface the role of a wp_tablet_tool cursor. A surface may only ever be used as the cursor surface for one wp_tablet_tool. If the surface already has another role or has previously been used as cursor surface for a different tool, a protocol error is raised.

Definition at line 7379 of file wayland-client-protocol-unstable.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## Member Data Documentation

## set_cursor_since_version

constexpr std::uint32_t wayland::zwp_tablet_tool_v2_t::set_cursor_since_version = 1

static constexpr

Minimum protocol version required for the set_cursor function.

Definition at line 4451 of file wayland-client-protocol-unstable.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol-unstable.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol-unstable.cpp